MBeanServerConnectionFactoryBean (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.jmx.support

## Class MBeanServerConnectionFactoryBean

- java.lang.Object
- - org.springframework.jmx.support.MBeanServerConnectionFactoryBean

- All Implemented Interfaces:
    Aware, BeanClassLoaderAware, DisposableBean, FactoryBean<MBeanServerConnection>, InitializingBean

      public class MBeanServerConnectionFactoryBean
      extends Object
      implements FactoryBean<MBeanServerConnection>, BeanClassLoaderAware, InitializingBean, DisposableBean

  `FactoryBean` that creates a JMX 1.2 `MBeanServerConnection` to a remote `MBeanServer` exposed via a `JMXServerConnector`. Exposes the `MBeanServer` for bean references.
  Since:
    1.2
  Author:
    Rob Harrop, Juergen Hoeller
  See Also:
    `MBeanServerFactoryBean`, `ConnectorServerFactoryBean`, `MBeanClientInterceptor.setServer(javax.management.MBeanServerConnection)`, `NotificationListenerRegistrar.setServer(javax.management.MBeanServerConnection)`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MBeanServerConnectionFactoryBean()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Creates a `JMXConnector` for the given settings and exposes the associated `MBeanServerConnection`.
    `void` | `destroy()` Closes the underlying `JMXConnector`.
    `MBeanServerConnection` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
    `Class<? extends MBeanServerConnection>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `void` | `setBeanClassLoader(ClassLoader classLoader)` Callback that supplies the bean `class loader` to a bean instance.
    `void` | `setConnectOnStartup(boolean connectOnStartup)` Set whether to connect to the server on startup.
    `void` | `setEnvironment(Properties environment)` Set the environment properties used to construct the `JMXConnector` as `java.util.Properties` (String key/value pairs).
    `void` | `setEnvironmentMap(Map<String,?> environment)` Set the environment properties used to construct the `JMXConnector` as a `Map` of String keys and arbitrary Object values.
    `void` | `setServiceUrl(String url)` Set the service URL of the remote `MBeanServer`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MBeanServerConnectionFactoryBean

          public MBeanServerConnectionFactoryBean()

  - ### Method Detail

    - #### setServiceUrl

          public void setServiceUrl(String url)
                             throws MalformedURLException

      Set the service URL of the remote `MBeanServer`.
      Throws:
        `MalformedURLException`

    - #### setEnvironment

          public void setEnvironment(Properties environment)

      Set the environment properties used to construct the `JMXConnector` as `java.util.Properties` (String key/value pairs).

    - #### setEnvironmentMap

          public void setEnvironmentMap(Map<String,?> environment)

      Set the environment properties used to construct the `JMXConnector` as a `Map` of String keys and arbitrary Object values.

    - #### setConnectOnStartup

          public void setConnectOnStartup(boolean connectOnStartup)

      Set whether to connect to the server on startup. Default is "true".

      Can be turned off to allow for late start of the JMX server. In this case, the JMX connector will be fetched on first access.

    - #### setBeanClassLoader

          public void setBeanClassLoader(ClassLoader classLoader)

      Description copied from interface: `BeanClassLoaderAware`
      Callback that supplies the bean `class loader` to a bean instance.

      Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean's` `InitializingBean.afterPropertiesSet()` method or a custom init-method.

      Specified by:
        `setBeanClassLoader` in interface `BeanClassLoaderAware`
      Parameters:
        `classLoader` - the owning class loader; may be `null` in which case a default `ClassLoader` must be used, for example the `ClassLoader` obtained via `ClassUtils.getDefaultClassLoader()`

    - #### afterPropertiesSet

          public void afterPropertiesSet()
                                  throws IOException

      Creates a `JMXConnector` for the given settings and exposes the associated `MBeanServerConnection`.
      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`
      Throws:
        `IOException`

    - #### getObject

          public MBeanServerConnection getObject()

      Description copied from interface: `FactoryBean`
      Return an instance (possibly shared or independent) of the object managed by this factory.

      As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

      If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

      As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

      Specified by:
        `getObject` in interface `FactoryBean<MBeanServerConnection>`
      Returns:
        an instance of the bean (can be `null`)
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<? extends MBeanServerConnection> getObjectType()

      Description copied from interface: `FactoryBean`
      Return the type of object that this FactoryBean creates, or `null` if not known in advance.

      This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

      In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

      This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

      NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

      Specified by:
        `getObjectType` in interface `FactoryBean<MBeanServerConnection>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<MBeanServerConnection>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

    - #### destroy

          public void destroy()
                       throws IOException

      Closes the underlying `JMXConnector`.
      Specified by:
        `destroy` in interface `DisposableBean`
      Throws:
        `IOException`